//******************************************************************************************
//      
// ATmega88,  GCC   WinAVR-20081205, HEX -  "Atmega88_USB_new.hex"
//  CKOPT = "0", BODEN = "0" (  12 ,  BOD )
//******************************************************************************************
#include "global.h" 			//   
//  
void HardInit(void);
// ,  
void pause(unsigned int time);
//   ,   USB 
unsigned char in_data[8];
//******************************************************************************************
int main(void) 					//   
{
	cli();

	asm("wdr");
	WDTCSR = (1<<WDCE) | (1<<WDE);
	asm("ldi r24, 0x28");		// 4 
	asm("std Z + 0, r24");

	HardInit();					//  ,  
								// . pullup  1.5   +5 ( PC2 = 0)
	pause(0x00FF);				// ,   ( 0,1 )
	usbDeviceConnect();			// . pullup  1.5   +5 ( PC2 = 1)
 	usbInit(); 					//  USB 
	sei(); 						//  
  	while (1) 					//         USB
  	{

		asm("wdr");

		out_data[2] = 0x55;

		if (((in_data[1] == 0xAA) && (in_data[2] == 0x55)) || (out_data[0] == 1)) 
			PORTD |= LED_YELLOW;
		else
			PORTD &= ~LED_YELLOW;

		if (((in_data[3] == 0x55) && (in_data[4] == 0xAA)) || (out_data[1] == 1)) 
			PORTD |= LED_GREEN;
		else
			PORTD &= ~LED_GREEN;


		//  
		if (!(PIND & BUTTON_1)){
			out_data[0] = 0x01;
			in_data[1] = 0x00;
			in_data[2] = 0x00;
		}
		else
			out_data[0] = 0x00;


		if (!(PINC & BUTTON_2)){
			out_data[1] = 0x01;
			in_data[3] = 0x00;
			in_data[4] = 0x00;
		}
		else
			out_data[1] = 0x00;


    	outSendData(); 			//     USB
    	usbPoll(); 				//     USB
  	}
}
//******************************************************************************************
//  
void HardInit(void)
{
	ACSR 	= (1<<ACD);			//  
	DDRB 	= 0x00; 			//  
  	PORTB 	= 0xFF;				//  
	DDRC 	= 0x04; 			// PC2 ,  
  	PORTC 	= 0xFB;				//   PC2 - 0,    
	DDRD 	|= 0xC0;			// PD7  PD6 ,  
  	PORTD 	|= 0x32;			// PD5, PD4  PD1   
}
//******************************************************************************************
// ,  
void pause(unsigned int time)
{
    static unsigned char a;
	
	while(time --> 0)
		for (a = 1; a; a ++)
			asm("wdr");
}
//******************************************************************************************
//   ,    USB  ,   in_data 
void usbFunctionWriteOut(uchar *data, uchar len)
{	
	unsigned char i = 0;

  	usbDisableAllRequests();

    while(len--)
		in_data[i ++] = *data ++;

    if(usbInterruptIsReady())
    	usbSetInterrupt(0, 0);
}
//******************************************************************************************




