//******************************************************************************************
#include "global.h" //   

//   ,   USB 
unsigned char out_data[3];
//******************************************************************************************
// USB  
static uchar usbReport[1 + sizeof(out_data)]; //   ReportID
//******************************************************************************************
// HID  
PROGMEM const char usbHidReportDescriptor[USB_CFG_HID_REPORT_DESCRIPTOR_LENGTH] =
{
    0x06, 0x00, 0xff,       // USAGE_PAGE (Vendor Defined Page 1)
    0x09, 0x01,        		// USAGE (Vendor Usage 1)
  	0xa1, 0x02, 			//   COLLECTION (Logical)
    0x85, 0x77,             	//   REPORT_ID (0x77)
    0x09, 0x01,                 //   USAGE (Pointer)
    0x15, 0x00,                 //   LOGICAL_MINIMUM (0)
    0x25, 0x01,                 //   LOGICAL_MAXIMUM (1)
    0x75, 0x08,                 //   REPORT_SIZE (8)
    0x95, 0x03,                 //   REPORT_COUNT (3)
    0x81, 0x02,                 //   INPUT (Data,Var,Abs)
    0x09, 0x01,                 //   USAGE (Pointer)
    0x15, 0x00,                 //   LOGICAL_MINIMUM (0)
    0x26, 0xff, 0x00,           //   LOGICAL_MAXIMUM (255)
    0x75, 0x08,                 //   REPORT_SIZE (8)
    0x95, 0x08,                 //   REPORT_COUNT (8)
    0x91, 0x02,                 //   OUTPUT (Data,Var,Abs)
    0xc0                	// END_COLLECTION
};
//******************************************************************************************
//     ReportID   
static uchar *usbBuildReport(uchar id)
{
	uchar i;
	uchar *dp = (void *) &out_data[0];
  	uchar *rp = usbReport;

  	//  ReportID
   	*rp++ = 0x77;
  	for (i = 0; i < sizeof(out_data); i++)
  		*rp++ = *dp++;

  //    
  return usbReport;
}
//******************************************************************************************
//     USB
uchar usbFunctionSetup(uchar data[8])
{
  	usbRequest_t *rq = (void *)data;

  	if ((rq->bmRequestType & USBRQ_TYPE_MASK) == USBRQ_TYPE_CLASS){
    	// return the report if host requests it without USB interrupt
    	if (rq->bRequest == USBRQ_HID_GET_REPORT){
      		// wValue: ReportType (highbyte), ReportID (lowbyte)
      		// build report requested
      		usbMsgPtr = usbBuildReport(rq->wValue.bytes[0]);
      		return sizeof(usbReport);
    	}
  	}
  	return 0;
}
//******************************************************************************************
// check if the USB Interrupt In point buffer is empty and return
// the data buffer for the following host request via USB interrupt
void outSendData(void)
{
  	if (usbInterruptIsReady()){
    	// fill in the report buffer and return the
    	// data pointer (Report ID is selected automatically)
    	usbSetInterrupt(usbBuildReport(0), sizeof(usbReport));
  	}
}
//******************************************************************************************
